//+------------------------------------------------------------------+
//|                                           Stochastic_fan_color   |
//|                                         Copyright  2012 Fox.RM  |
//|                                               fox.rm@mail.ru     |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012 Fox.RM"
#property link      "fox.rm@mail.ru"

//----
#property indicator_separate_window
#property indicator_buffers 7

//---- fan style
#property indicator_color1 Red
#property indicator_color2 Black
#property indicator_color3 Blue
#property indicator_color4 Red
#property indicator_color5 Blue
#property indicator_color6 SlateBlue
#property indicator_color7 Tomato

#property indicator_style1 0
#property indicator_style2 0
#property indicator_style3 0
#property indicator_width4 2
#property indicator_width5 2
#property indicator_width6 2
#property indicator_width7 2

#property indicator_level1 88.2
#property indicator_level2 11.8
 
#property indicator_levelcolor DarkGray

//---- basic fan indicator parameters
extern bool Show_STOCH_1=true;
extern int K_period1=21;
extern int S_period1=1;
extern bool Show_STOCH_2=true;
extern int K_period2=55;
extern int S_period2=1;
extern bool Show_STOCH_3=true;
extern int K_period3=144;
extern int S_period3=1;
extern bool Show_STOCH_4=true;
extern int K_period4=377;
extern int S_period4=1;


//---- indicator buffers
double MainBuffer1[];
double MainBuffer2[];
double MainBuffer3[];
double MainBufferR[];
double MainBufferB[];
double MainBufferS[];
double MainBufferT[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
  {
//---- stochastic line 1 (fast)
   if(Show_STOCH_1 ==true){Show_STOCH_1=DRAW_LINE; }
   else 
    {Show_STOCH_1=DRAW_NONE; }
   SetIndexBuffer(0,MainBuffer1);
   SetIndexStyle(0,Show_STOCH_1,0);
   SetIndexLabel(0,"fast WPR  ( "+K_period1+" )");
   
//---- stochastic line 2 (basic)
   if(Show_STOCH_2 ==true){Show_STOCH_2=DRAW_LINE; }
   else 
    {Show_STOCH_2=DRAW_NONE; }
   SetIndexBuffer(1,MainBuffer2);
   SetIndexStyle(1,Show_STOCH_2);
   SetIndexLabel(1,"basic WPR ( "+K_period2+" )");
   
//---- stochastic line 3 (flat)
   if(Show_STOCH_3 ==true){Show_STOCH_3=DRAW_LINE; }
   else 
    {Show_STOCH_3=DRAW_NONE; }
   SetIndexBuffer(2,MainBuffer3);
   SetIndexStyle(2,Show_STOCH_3,0);
   SetIndexLabel(2,"slow WPR ( "+K_period3+" )");
   
//---- stochastic line 4 (control)
   
   SetIndexBuffer(3,MainBufferR);
   SetIndexStyle(3,Show_STOCH_4,0,2);
   SetIndexLabel(3,"control WPR ( "+K_period4+" )");
   SetIndexBuffer(4,MainBufferB);
   SetIndexBuffer(5,MainBufferS);
   SetIndexBuffer(6,MainBufferT);
   
//---- name for DataWindow and indicator subwindow label   
   IndicatorShortName("Stochastic_fan_color");
  }

//----
   return(0);

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+

int deinit()
  {
//---- 
   ObjectsDeleteAll(0,OBJ_LABEL);
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Stochastic_fan                                                   |
//+------------------------------------------------------------------+

int start()
  {
  
double MA1[];
double MA2[];
double MA3[];
double VolumesBuf[];
  
   int    i,limit,counted_bars=IndicatorCounted();

//---- Plot defined timeframe on to current timeframe   
 
   limit=Bars-counted_bars;
   //---stroim stohastik
   for(i=0;i<limit;i++)
     {
     //---   Volume    
      VolumesBuf[i]=Volume[i];
      MA1[i]=iMAOnArray(VolumesBuf,0,8,0,0,i);
      MA2[i]=iMAOnArray(VolumesBuf,0,21,0,0,i);
      MA3[i]=iMAOnArray(VolumesBuf,0,233,0,0,i);
     //---          
      MainBuffer1[i]=iStochastic(NULL,0,K_period1,1,S_period1,0,0,MODE_MAIN,0);
      MainBuffer2[i]=iStochastic(NULL,0,K_period2,1,S_period2,0,0,MODE_MAIN,0);
      MainBuffer3[i]=iStochastic(NULL,0,K_period3,1,S_period3,0,0,MODE_MAIN,0);
      MainBufferR[i]=iStochastic(NULL,0,K_period4,1,S_period4,0,0,MODE_MAIN,0);
      MainBufferB[i]=iStochastic(NULL,0,K_period4,1,S_period4,0,0,MODE_MAIN,0);
      MainBufferS[i]=iStochastic(NULL,0,K_period4,1,S_period4,0,0,MODE_MAIN,0);
      MainBufferT[i]=iStochastic(NULL,0,K_period4,1,S_period4,0,0,MODE_MAIN,0);
     //---     
 if(MA1[i]>MA3[i]&&MA1[i]>MA2[i]){MainBufferB[i]=EMPTY;MainBufferS[i]=EMPTY;MainBufferT[i]=EMPTY;}
 if(MA1[i]>MA3[i]&&MA1[i]<MA2[i]){MainBufferB[i]=EMPTY;MainBufferS[i]=EMPTY;MainBufferR[i]=EMPTY;}
 if(MA1[i]<MA3[i]&&MA1[i]>MA2[i]){MainBufferB[i]=EMPTY;MainBufferT[i]=EMPTY;MainBufferR[i]=EMPTY;}
 if(MA1[i]<MA3[i]&&MA1[i]<MA2[i]){MainBufferR[i]=EMPTY;MainBufferT[i]=EMPTY;MainBufferS[i]=EMPTY;}        
    
//-- Uslovia na raskras


}
//----
        return(0);
  }
//+------------------------------------------------------------------+